//+------------------------------------------------------------------+
//|                                                   Arbitrager.mq4 |
//|                        Copyright 2013, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "Copyright 2013, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net"


extern int magik=12321;
extern double LotDepo=150;
extern double Arbitrag=0.02;
string Symbol_="";
//+------------------------------------------------------------------+
//| script program start function                                    |
//+------------------------------------------------------------------+
int init()
{
   Symbol_=Symbol();
}
int start()
  {
//----
   double  Bid_LTCBTC=MarketInfo("LTCBTC",MODE_BID);
   double  Ask_LTC=MarketInfo("LTCUSD",MODE_ASK);
   double  Bid_BTC=MarketInfo("BTCUSD",MODE_BID);
   double Bid_Sell=Ask_LTC/Bid_BTC;
   double Ask_LTCBTC=MarketInfo("LTCBTC",MODE_ASK);
   double Bid_LTC=MarketInfo("LTCUSD",MODE_BID);
   double Ask_BTC=MarketInfo("BTCUSD",MODE_ASK);
   double Ask_Buy=Bid_LTC/Ask_BTC;
   int tBuy=0,tSell=0,i=0,cmd=0;
   double Lot=0;
   if(Symbol_=="LTCBTC")
   {
      while(!IsStopped())
      {
         RefreshRates();
         tBuy=0;tSell=0;
         Bid_LTCBTC=MarketInfo("LTCBTC",MODE_BID);
         Ask_LTC=MarketInfo("LTCUSD",MODE_ASK);
         Bid_BTC=MarketInfo("BTCUSD",MODE_BID);
         Bid_Sell=Ask_LTC/Bid_BTC;
         Ask_LTCBTC=MarketInfo("LTCBTC",MODE_ASK);
         Bid_LTC=MarketInfo("LTCUSD",MODE_BID);
         Ask_BTC=MarketInfo("BTCUSD",MODE_ASK);
         Ask_Buy=Bid_LTC/Ask_BTC;
         for(i=OrdersTotal()-1;i>=0;i--)
         {
            if(OrderSelect(i,SELECT_BY_POS)&&OrderMagicNumber()==magik&&OrderSymbol()==Symbol_)
            {
               cmd=OrderType();
               if(cmd==OP_BUY)
               {
                  if(Bid_Sell+Bid_Sell*Arbitrag<Bid_LTCBTC)
                  {
                     CAO();
                  }
                  tBuy++;
               }
               if(cmd==OP_SELL)
               {
                  if(Ask_Buy-Ask_Buy*Arbitrag>Ask_LTCBTC)
                  {
                     CAO();
                  }
                  tSell++;
               }
            }
         }
         if(Bid_Sell+Bid_Sell*Arbitrag<Bid_LTCBTC)
         {
            Lot=NL(Symbol_,LotDepo/MarketInfo("LTCUSD",MODE_BID));
            if(tSell==0&&tBuy==0&&AccountFreeMargin()>LotDepo*1.5)OrderSend(Symbol_,OP_SELL,Lot,n(MarketInfo(Symbol_,MODE_BID)),0,0,0,NULL,magik);
         }
         if(Ask_Buy-Ask_Buy*Arbitrag>Ask_LTCBTC)
         {
            Lot=NL(Symbol_,LotDepo/MarketInfo("LTCUSD",MODE_ASK));
            if(tBuy==0&&tSell==0&&AccountFreeMargin()>LotDepo*1.5)OrderSend(Symbol_,OP_BUY,Lot,n(MarketInfo(Symbol_,MODE_ASK)),0,0,0,NULL,magik);
         }
         Sleep(100);
      }
   }
   if(Symbol_=="LTCUSD")
   {
      while(!IsStopped())
      {
         RefreshRates();
         tBuy=0;tSell=0;
         Bid_LTCBTC=MarketInfo("LTCBTC",MODE_BID);
         Ask_LTC=MarketInfo("LTCUSD",MODE_ASK);
         Bid_BTC=MarketInfo("BTCUSD",MODE_BID);
         Bid_Sell=Ask_LTC/Bid_BTC;
         Ask_LTCBTC=MarketInfo("LTCBTC",MODE_ASK);
         Bid_LTC=MarketInfo("LTCUSD",MODE_BID);
         Ask_BTC=MarketInfo("BTCUSD",MODE_ASK);
         Ask_Buy=Bid_LTC/Ask_BTC;
         for(i=OrdersTotal()-1;i>=0;i--)
         {
            if(OrderSelect(i,SELECT_BY_POS)&&OrderMagicNumber()==magik&&OrderSymbol()==Symbol_)
            {
               cmd=OrderType();
               if(cmd==OP_BUY)
               {
                  if(Ask_Buy-Ask_Buy*Arbitrag>Ask_LTCBTC)
                  {
                     CAO();
                  }
                  tBuy++;
               }
               if(cmd==OP_SELL)
               {
                  if(Bid_Sell+Bid_Sell*Arbitrag<Bid_LTCBTC)
                  {
                     CAO();
                  }
                  tSell++;
               }
            }
         }
         if(Bid_Sell+Bid_Sell*Arbitrag<Bid_LTCBTC)
         {
            Lot=NL(Symbol_,LotDepo/Ask);
            if(tBuy==0&&tSell==0&&AccountFreeMargin()>LotDepo*1.5)OrderSend(Symbol_,OP_BUY,Lot,n(MarketInfo(Symbol_,MODE_ASK)),0,0,0,NULL,magik);
         }
         if(Ask_Buy-Ask_Buy*Arbitrag>Ask_LTCBTC)
         {
            Lot=NL(Symbol_,LotDepo/Bid);
            if(tSell==0&&tBuy==0&&AccountFreeMargin()>LotDepo*1.5)OrderSend(Symbol_,OP_SELL,Lot,n(MarketInfo(Symbol_,MODE_BID)),0,0,0,NULL,magik);
         }
         Sleep(100);
      }
   }
   if(Symbol_=="BTCUSD")
   {
      while(!IsStopped())
      {
         RefreshRates();
         tBuy=0;tSell=0;
         Bid_LTCBTC=MarketInfo("LTCBTC",MODE_BID);
         Ask_LTC=MarketInfo("LTCUSD",MODE_ASK);
         Bid_BTC=MarketInfo("BTCUSD",MODE_BID);
         Bid_Sell=Ask_LTC/Bid_BTC;
         Ask_LTCBTC=MarketInfo("LTCBTC",MODE_ASK);
         Bid_LTC=MarketInfo("LTCUSD",MODE_BID);
         Ask_BTC=MarketInfo("BTCUSD",MODE_ASK);
         Ask_Buy=Bid_LTC/Ask_BTC;
         for(i=OrdersTotal()-1;i>=0;i--)
         {
            if(OrderSelect(i,SELECT_BY_POS)&&OrderMagicNumber()==magik&&OrderSymbol()==Symbol_)
            {
               cmd=OrderType();
               if(cmd==OP_BUY)
               {
                  if(Bid_Sell+Bid_Sell*Arbitrag<Bid_LTCBTC)
                  {
                     CAO();
                  }
                  tBuy++;
               }
               if(cmd==OP_SELL)
               {
                  if(Ask_Buy-Ask_Buy*Arbitrag>Ask_LTCBTC)
                  {
                     CAO();
                  }
                  tSell++;
               }
            }
         }
         if(Bid_Sell+Bid_Sell*Arbitrag<Bid_LTCBTC)
         {
            Lot=NL(Symbol_,LotDepo/Bid);
            if(tSell==0&&tBuy==0&&AccountFreeMargin()>LotDepo*1.5)OrderSend(Symbol_,OP_SELL,Lot,n(MarketInfo(Symbol_,MODE_BID)),0,0,0,NULL,magik);
         }
         if(Ask_Buy-Ask_Buy*Arbitrag>Ask_LTCBTC)
         {
            Lot=NL(Symbol_,LotDepo/Ask);
            if(tBuy==0&&tSell==0&&AccountFreeMargin()>LotDepo*1.5)OrderSend(Symbol_,OP_BUY,Lot,n(MarketInfo(Symbol_,MODE_ASK)),0,0,0,NULL,magik);
         }
         Sleep(100);
      }
   }
//----
   return(0);
  }
//+------------------------------------------------------------------+
double n(double val)
{return(NormalizeDouble(val,Digits));}
void CAO()
{
   for(int i=OrdersTotal()-1;i>=0;i--)
   {
      if(OrderSelect(i,SELECT_BY_POS)&&OrderMagicNumber()==magik&&OrderSymbol()==Symbol_)
      {
         int cmd=OrderType();
         if(cmd==OP_BUY)
         {
            OrderClose(OrderTicket(),OrderLots(),n(Bid),100000);
         }
         if(cmd==OP_SELL)
         {
            OrderClose(OrderTicket(),OrderLots(),n(Ask),100000);
         }
      }
   }
   return;
}
double NL (string Sym,double lots) {
   double step=MarketInfo(Sym,MODE_LOTSTEP);
   return (MathRound(lots/step)*step);
}

